diff --git a/lib/hive/claude_launcher.rb b/lib/hive/claude_launcher.rb
index b6820a41..1e8a60cc 100644
--- a/lib/hive/claude_launcher.rb
+++ b/lib/hive/claude_launcher.rb
@@ -833,81 +1023,385 @@ module Hive
       false
     end
 
-    def capture_limit_tail(runner)
-      return "" unless runner.respond_to?(:capture_pane_tail)
-
-      runner.capture_pane_tail(bytes: SENTINEL_CAPTURE_BYTES)
-    rescue Hive::TmuxError
-      ""
-    end
-
-    def wait_for_done_signal(task, runner, timeout, log_label)
+    def wait_for_done_signal(task, runner, timeout, log_label,
+                             completion_probe: nil, completion_phase: nil,
+                             before_completion_probe: nil)
       deadline = Time.now + timeout
+      lifecycle = completion_lifecycle
       loop do
         # A usage/credit wall stalls claude WITHOUT ever touching `.done`,
         # so this exit_code_only path (the default `claude`/tmux execute
         # spawn) would otherwise drain to the generic "stop hook did not
         # signal completion" timeout — a marker with no limit text, which
         # the execute classifier reads as `implementer_failed` rather than
-        # `limits_reached`. Mirror the sibling wait modes
-        # (`wait_for_expected_output`, `limits_reached_marker`): surface a
-        # detected wall as an :error carrying the limit error_message so the
-        # execute stage stamps `reason="limits_reached"` and the cooldown
-        # healer can hold/retry. `capture_limit_tail` is nil-runner safe.
-        pane_tail = capture_limit_tail(runner)
-        if (limit_line = Hive::AgentLimit.live_limit_line(pane_tail))
+        # `limits_reached`. Surface a detected wall as an :error carrying the
+        # limit error_message so the execute stage stamps
+        # `reason="limits_reached"` and the cooldown healer can hold/retry.
+        pane_tail, pane_error = capture_completion_tail(runner)
+        if pane_error
+          lifecycle[:session_readable] = false
           return {
             status: :error,
-            limit_text: limit_line,
-            error_message: Hive::AgentLimit.error_message(limit_line, agent: "claude")
+            error_message: "tmux_pane_unreadable: #{pane_error}",
+            fallback_decision: fallback_decision(task, runner, lifecycle, completion_phase, nil)
           }
         end
-
         if File.exist?(done_path(task))
           # The stop-hook touches `.done` even on `empty_stdin` /
           # other non-success completions; the real status lives in
           # `result.json`. Without this check, an exit_code_only
           # caller (e.g. the Phase 4 fix agent) would see `:ok` for
           # an errored claude run.
-          status = read_result_json_status(task)
-          if status == :ok
-            return { status: :ok, log_label: log_label }
-          elsif status
-            return { status: status, log_label: log_label,
-                     error_message: "claude reported #{status.inspect} via result.json" }
+          return result_json_completion(task, log_label)
+        end
+        if (failure = completion_failure_result(
+          task, runner, lifecycle, completion_phase, pane_tail
+        ))
+          return failure
+        end
+
+        # The fallback is intentionally limited to callers that provide a
+        # semantic probe. Track a real busy→idle lifecycle rather than
+        # accepting the cold-start prompt that is already idle before work.
+        if completion_probe
+          update_completion_lifecycle!(lifecycle, pane_tail)
+          if lifecycle[:stable_idle]
+            return complete_fallback_attempt(
+              task: task,
+              runner: runner,
+              deadline: deadline,
+              lifecycle: lifecycle,
+              completion_probe: completion_probe,
+              completion_phase: completion_phase || "exit_code_only",
+              before_completion_probe: before_completion_probe,
+              log_label: log_label,
+              success_status: :ok,
+              normal_completion: lambda {
+                File.exist?(done_path(task)) ? result_json_completion(task, log_label) : nil
+              }
+            )
           end
-          # No result.json on disk yet — the .done write may have
-          # raced the result write. Treat as completion since
-          # exit_code_only callers don't carry a richer contract.
-          return { status: :ok, log_label: log_label }
         end
 
         if Time.now >= deadline
-          return { status: :timeout, error_message: "claude stop hook did not signal completion" }
+          return {
+            status: :timeout,
+            error_message: "claude stop hook did not signal completion",
+            fallback_decision: fallback_decision(task, runner, lifecycle, completion_phase, nil)
+          }
         end
 
         sleep [ poll_interval, deadline - Time.now ].min
       end
     end
 
-    # Read `result.json` (if present) and translate `status` into the
-    # caller's symbol vocabulary. Unknown / unparseable shapes return
-    # nil so the caller can fall through to its default success path.
+    def completion_lifecycle
+      {
+        work_started: false,
+        returned_to_idle: false,
+        stable_idle: false,
+        idle_polls: 0,
+        session_readable: true,
+        no_failure_output: true
+      }
+    end
+
+    def completion_failure_result(task, runner, lifecycle, phase, pane_tail)
+      if (limit_line = Hive::AgentLimit.live_limit_line(pane_tail))
+        lifecycle[:no_failure_output] = false
+        return {
+          status: :error,
+          limit_text: limit_line,
+          error_message: Hive::AgentLimit.error_message(limit_line, agent: "claude"),
+          fallback_decision: fallback_decision(
+            task, runner, lifecycle, phase, nil
+          )
+        }
+      end
+      return nil unless pane_tail.match?(CLAUDE_COMPLETION_FAILURE_LINE)
+
+      lifecycle[:no_failure_output] = false
+      {
+        status: :error,
+        error_message: "claude tmux pane reported a failure before completion",
+        fallback_decision: fallback_decision(
+          task, runner, lifecycle, phase, nil
+        )
+      }
+    end
+
+    def complete_fallback_attempt(task:, runner:, deadline:, lifecycle:,
+                                  completion_probe:, completion_phase:,
+                                  before_completion_probe:, log_label:,
+                                  success_status:, normal_completion:)
+      # Capture identity while the live pane is still queryable. A real tmux
+      # runner cannot answer pane_pid after kill-session; identity is evidence,
+      # not something to reconstruct from a dead session during classification.
+      identity = fallback_identity(runner)
+      lifecycle[:session_readable] = false if identity[:error]
+
+      # A delayed ordinary Stop signal wins until the controlled exit starts.
+      if (normal = normal_completion.call)
+        return normal
+      end
+
+      exit_status, exit_error = controlled_tmux_exit_status(runner, deadline)
+      lifecycle[:session_readable] = false if exit_error
+
+      # `/quit` may flush a late Stop callback. Classify it through the same
+      # strict result-before-sentinel contract as an on-time callback.
+      if (normal = normal_completion.call)
+        return normal
+      end
+
+      before_completion_probe&.call
+      probe = invoke_completion_probe(completion_probe, task, completion_phase)
+
+      # The synchronous semantic probe can take long enough for a delayed Stop
+      # callback to publish result.json + .done. Recheck after the probe so the
+      # ordinary protocol still wins and no fallback audit is emitted.
+      if (normal = normal_completion.call)
+        return normal
+      end
+
+      decision = fallback_decision(
+        task, runner, lifecycle, completion_phase, probe,
+        exit_status: exit_status, identity: identity
+      )
+      if decision.accepted?
+        emit_completion_fallback!(task, decision, log_label)
+        return {
+          status: success_status,
+          log_label: log_label,
+          completion: :fallback,
+          completion_audited: true,
+          fallback_decision: decision,
+          completion_probe: probe
+        }
+      end
+
+      {
+        status: :timeout,
+        error_message: "claude stop hook did not signal completion",
+        fallback_decision: decision,
+        completion_probe: probe
+      }
+    rescue StandardError => e
+      lifecycle[:session_readable] = false
+      decision = fallback_decision(
+        task, runner, lifecycle, completion_phase,
+        { accepted: false, rejection_reason: "fallback finalization failed: #{e.class}: #{e.message}" },
+        identity: identity
+      )
+      {
+        status: :timeout,
+        error_message: "claude stop hook did not signal completion",
+        fallback_decision: decision
+      }
+    end
+
+    def combine_completion_probes(primary, secondary)
+      return primary unless secondary
+
+      lambda do |task:, phase:|
+        first = invoke_completion_probe(primary, task, phase)
+        return first unless first[:accepted]
+
+        second = invoke_completion_probe(secondary, task, phase)
+        return second unless second[:accepted]
+
+        first.merge(
+          second,
+          accepted: true,
+          artifacts_checked: (
+            Array(first[:artifacts_checked]) + Array(second[:artifacts_checked])
+          ).uniq
+        )
+      end
+    end
+
+    def result_json_completion(task, log_label, success_status: :ok)
+      status = read_result_json_status(task)
+      if status == :ok
+        { status: success_status, log_label: log_label }
+      elsif status == :invalid_result
+        {
+          status: :error,
+          log_label: log_label,
+          error_message: "claude Stop sentinel had invalid or missing result.json"
+        }
+      else
+        {
+          # Callers should never need to enumerate provider-specific Stop
+          # statuses to stay fail-closed. Preserve the reported value in the
+          # message, but normalize every valid non-success result to the
+          # launcher's shared failure status.
+          status: :error,
+          log_label: log_label,
+          error_message: "claude reported #{status.inspect} via result.json"
+        }
+      end
+    end
+
+    # A Claude pane is only a lifecycle signal, never success evidence. The
+    # prompt must first disappear (work started) and then return for two
+    # consecutive reads (stable idle). A one-off cold-start caret therefore
+    # cannot trigger a probe or fallback acceptance.
+    def update_completion_lifecycle!(lifecycle, pane_tail)
+      if claude_ready_prompt?(pane_tail)
+        if lifecycle[:work_started]
+          lifecycle[:returned_to_idle] = true
+          lifecycle[:idle_polls] += 1
+          lifecycle[:stable_idle] = lifecycle[:idle_polls] >= 2
+        end
+      else
+        lifecycle[:work_started] = true
+        lifecycle[:idle_polls] = 0
+      end
+    end
+
+    def capture_completion_tail(runner)
+      return [ "", nil ] unless runner && runner.respond_to?(:capture_pane_tail)
+
+      [ runner.capture_pane_tail(bytes: SENTINEL_CAPTURE_BYTES), nil ]
+    rescue Hive::TmuxError => e
+      [ "", e.message ]
+    end
+
+    def invoke_completion_probe(probe, task, phase)
+      result = probe.call(task: task, phase: phase)
+      return result.merge(accepted: result[:accepted] == true) if result.is_a?(Hash)
+
+      { accepted: false, rejection_reason: "completion probe returned #{result.class}, not Hash" }
+    rescue StandardError => e
+      { accepted: false, rejection_reason: "completion probe failed: #{e.class}: #{e.message}" }
+    end
+
+    def fallback_decision(task, runner, lifecycle, phase, probe,
+                          exit_status: nil, identity: nil)
+      probe ||= { accepted: false, rejection_reason: "completion probe was not run" }
+      identity ||= fallback_identity(runner)
+      lifecycle[:session_readable] = false if identity[:error]
+      Hive::ClaudeCompletionFallback.evaluate(
+        Hive::ClaudeCompletionFallback::Evidence.new(
+          phase: phase || "exit_code_only",
+          sentinel_path: done_path(task),
+          missing_signal_reason: "stop_hook_sentinel_missing",
+          session_name: identity[:session_name],
+          pane_pid: identity[:pane_pid],
+          sentinel_missing: !File.exist?(done_path(task)),
+          work_started: lifecycle[:work_started],
+          returned_to_idle: lifecycle[:returned_to_idle],
+          stable_idle: lifecycle[:stable_idle],
+          session_readable: lifecycle[:session_readable],
+          no_failure_output: lifecycle[:no_failure_output],
+          no_failure_result: retained_result_allows_fallback?(task),
+          probe_accepted: probe[:accepted] == true,
+          exit_status: exit_status,
+          probe: probe
+        )
+      )
+    end
+
+    def retained_result_allows_fallback?(task)
+      path = result_path(task)
+      return true unless File.exist?(path)
+
+      read_result_json_status(task) == :ok
+    end
+
+    def emit_completion_fallback!(task, decision, log_label)
+      fields = decision.to_h
+      phase = fields[:phase] || "unknown"
+      message = Hive::ClaudeCompletionFallback.audit_message(
+        task_slug: task_slug(task),
+        pass: completion_pass(log_label),
+        fields: fields
+      )
+      record = Hive::Events.emit(
+        task_folder: task.folder,
+        slug: task_slug(task),
+        stage: completion_stage(task),
+        agent: "claude #{phase.tr('_', '-')}",
+        event_type: :claude_completion_fallback,
+        message: message
+      )
+      raise Hive::Error, "event log write returned no record" unless record
+
+      record
+    end
+
+    def completion_pass(log_label)
+      match = log_label.to_s.match(/pass(?<pass>\d+)/)
+      match ? match[:pass].to_i : "unknown"
+    end
+
+    def completion_stage(task)
+      if task.respond_to?(:stage_index) && task.respond_to?(:stage_name)
+        return "#{task.stage_index}-#{task.stage_name}"
+      end
+
+      File.basename(File.dirname(task.folder.to_s))
+    end
+
+    def fallback_identity(runner)
+      return { session_name: nil, pane_pid: nil, error: nil } unless runner
+
+      {
+        session_name: runner.respond_to?(:name) ? runner.name : nil,
+        pane_pid: runner.respond_to?(:pane_pid) ? runner.pane_pid : nil,
+        error: nil
+      }
+    rescue Hive::TmuxError => e
+      { session_name: nil, pane_pid: nil, error: e.message }
+    end
+
+    # Quit only after lifecycle plus semantic evidence are available. tmux's
+    # remain-on-exit gives us a truthful numeric status; unknown, vanished, or
+    # nonzero exits are deliberately not coerced to success. The enclosing
+    # shared-session ensure owns kill-session after the fallback decision has
+    # consumed the live pane identity.
+    def controlled_tmux_exit_status(runner, deadline)
+      return [ nil, "runner does not support controlled exit" ] unless runner &&
+                                                                  runner.respond_to?(:enable_remain_on_exit) &&
+                                                                  runner.respond_to?(:pane_dead?) &&
+                                                                  runner.respond_to?(:pane_dead_status) &&
+                                                                  runner.respond_to?(:send_prompt)
+
+      runner.enable_remain_on_exit
+      runner.send_prompt("/quit")
+      loop do
+        if runner.pane_dead?
+          status = runner.pane_dead_status
+          return [ status, status.is_a?(Integer) ? nil : "pane_dead_status unreadable" ]
+        end
+        return [ nil, "controlled tmux shutdown timed out" ] if Time.now >= deadline
+
+        sleep [ poll_interval, [ deadline - Time.now, 0 ].max ].min
+      end
+    rescue Hive::TmuxError => e
+      [ nil, e.message ]
+    end
+
+    # Read `result.json` and translate `status` into the caller's symbol
+    # vocabulary. A visible sentinel is never sufficient by itself: absent,
+    # empty, malformed, statusless, and non-object results all fail closed.
     def read_result_json_status(task)
       path = result_path(task)
-      return nil unless File.exist?(path) && File.size(path).positive?
+      return :invalid_result unless File.file?(path) && File.size(path).positive?
 
       data = JSON.parse(File.read(path))
-      return nil unless data.is_a?(Hash)
+      return :invalid_result unless data.is_a?(Hash)
+
+      raw = data["status"]
+      return :invalid_result unless raw.is_a?(String) && raw.match?(/\A[a-z][a-z0-9_-]{0,63}\z/)
 
-      raw = data["status"].to_s
       case raw
       when "ok", "complete", "success" then :ok
-      when "" then nil
       else raw.to_sym
       end
     rescue JSON::ParserError, SystemCallError, IOError
-      nil
+      :invalid_result
     end
 
     def poll_interval
@@ -1094,11 +1588,11 @@ module Hive
     end
 
     def done_path(task)
-      File.join(task.folder, ".done")
+      Hive::StopHookInstaller.completion_paths(task.folder).first
     end
 
     def result_path(task)
-      File.join(task.folder, "result.json")
+      Hive::StopHookInstaller.completion_paths(task.folder).last
     end
 
     # Like the (removed) bare `safe` helper, but logs the swallowed
@@ -1119,6 +1613,7 @@ module Hive
     def shutdown_claude(runner)
       return unless runner
       return if runner.respond_to?(:session_exists?) && !runner.session_exists?
+      return if runner.respond_to?(:pane_dead?) && runner.pane_dead?
 
       runner.send_prompt("/quit") if runner.respond_to?(:send_prompt)
       sleep claude_shutdown_grace
diff --git a/lib/hive/events.rb b/lib/hive/events.rb
index 31ecc07a..f8bca816 100644
--- a/lib/hive/events.rb
+++ b/lib/hive/events.rb
@@ -14,6 +14,7 @@ module Hive
       round_waiting
       round_complete
       clean_exit_auto_committed
+      claude_completion_fallback
     ].freeze
 
     STATUS_TAIL_LINES = 20
diff --git a/lib/hive/scripts/stop_hook.sh b/lib/hive/scripts/stop_hook.sh
index 086433f0..499f9e11 100755
--- a/lib/hive/scripts/stop_hook.sh
+++ b/lib/hive/scripts/stop_hook.sh
@@ -3,16 +3,39 @@ set -eu
 
 : "${HIVE_TASK_STAGE_DIR:?HIVE_TASK_STAGE_DIR required}"
 
-# Buffer stdin first so an empty payload doesn't silently produce a
-# zero-byte result.json — that file is forensic evidence, and an empty
-# write is indistinguishable from "hook ran but Claude Code passed no
-# data". If stdin is empty, write an explicit sentinel JSON object
-# instead so the operator can tell the difference.
-result_path="${HIVE_TASK_STAGE_DIR}/result.json"
-payload=$(cat)
-if [ -z "$payload" ]; then
-  printf '%s\n' '{"hive_stop_hook":"empty_stdin"}' > "$result_path"
-else
-  printf '%s' "$payload" > "$result_path"
-fi
-touch "${HIVE_TASK_STAGE_DIR}/.done"
+# Do not re-derive these paths from the current directory: the launcher
+# resolves them and installs those literal values into every active settings
+# scope. The hook's contract is publish parseable result JSON atomically,
+# THEN make the completion sentinel observable. A failed parse/write must
+# never look like success merely because `.done` exists.
+result_path="${HIVE_STOP_HOOK_RESULT_PATH:-${HIVE_TASK_STAGE_DIR}/result.json}"
+done_path="${HIVE_STOP_HOOK_DONE_PATH:-${HIVE_TASK_STAGE_DIR}/.done}"
+result_dir=$(dirname "$result_path")
+mkdir -p "$result_dir"
+tmp_path=$(mktemp "${result_dir}/.$(basename "$result_path").tmp.XXXXXX")
+trap 'rm -f "$tmp_path"' EXIT HUP INT TERM
+
+# Claude supplies a JSON Stop payload. Normalize the empty payload into a
+# forensic object and append hook timing/process metadata without changing
+# its reported status. Claude's ordinary Stop payload does not guarantee a
+# `status` field, so a successfully parsed object gets the explicit success
+# status consumed by ClaudeLauncher. Empty stdin is still published for
+# forensics, but with a non-success status so its sentinel cannot promote the
+# turn to success. Ruby is already a runtime dependency of hive and gives us
+# strict JSON parsing rather than shell-string interpolation.
+ruby -rjson -rtime -e '
+  payload = STDIN.read
+  data = if payload.strip.empty?
+    { "status" => "empty_stdin", "hive_stop_hook" => "empty_stdin" }
+  else
+    JSON.parse(payload)
+  end
+  abort "Stop hook payload must be a JSON object" unless data.is_a?(Hash)
+  data["status"] = "success" unless data.key?("status")
+  data["hive_stop_hook_invoked_at"] = Time.now.utc.iso8601
+  data["hive_stop_hook_pid"] = Process.pid
+  data["hive_stop_hook_session"] = ENV["HIVE_TMUX_SESSION"] if ENV["HIVE_TMUX_SESSION"]
+  STDOUT.write(JSON.generate(data))
+' > "$tmp_path"
+mv -f "$tmp_path" "$result_path"
+touch "$done_path"
diff --git a/lib/hive/stages/base.rb b/lib/hive/stages/base.rb
index 979b4800..0d76dfe9 100644
--- a/lib/hive/stages/base.rb
+++ b/lib/hive/stages/base.rb
@@ -562,7 +562,8 @@ module Hive
                          profile: nil, expected_output: nil, status_mode: nil,
                          permission_mode: nil, allowed_tools: nil,
                          disallowed_tools: nil, mcp_config_path: nil,
-                         strict_mcp_config: false)
+                         strict_mcp_config: false, completion_probe: nil,
+                         completion_phase: nil)
         require "hive/claude_launcher"
 
         profile ||= Hive::AgentProfiles.lookup(:claude, cfg: cfg)
@@ -588,7 +589,9 @@ module Hive
           allowed_tools: allowed_tools,
           disallowed_tools: disallowed_tools,
           mcp_config_path: mcp_config_path,
-          strict_mcp_config: strict_mcp_config
+          strict_mcp_config: strict_mcp_config,
+          completion_probe: completion_probe,
+          completion_phase: completion_phase
         )
       end
 
diff --git a/lib/hive/stages/review.rb b/lib/hive/stages/review.rb
index 7ca0fb20..eeae0e30 100644
--- a/lib/hive/stages/review.rb
+++ b/lib/hive/stages/review.rb
@@ -23,6 +23,7 @@ require "hive/stages/review/ci_fix"
 require "hive/stages/review/triage"
 require "hive/stages/review/browser_test"
 require "hive/stages/review/fix_guardrail"
+require "hive/stages/review/fix_completion"
 require "hive/stages/review/github_publisher"
 require "hive/workflows"
 
@@ -79,7 +80,7 @@ module Hive
       # Phase 4 with the operator's existing `[x]` marks instead of
       # advancing past them.
       FIX_SUCCESS_FILENAME = "fix-success".freeze
-      AcceptedFindings = Data.define(:text, :count)
+      AcceptedFindings = Data.define(:text, :count, :finding_ids)
       # Resolved reviewer compare base. `degraded` is true when the
       # configured compare ref did not resolve and we fell back to the
       # worktree HEAD (or an unresolved-ref token). The base is resolved
@@ -579,13 +580,40 @@ module Hive
             "reviews/suppressed.md",
             fix_success_relative_path(pass)
           ]
+          # Reviewer files are immutable fix inputs. Triage may edit them
+          # before Phase 4, but the fixer may neither rewrite nor delete the
+          # accepted-finding source it is later asked to prove it addressed.
+          protected_set.concat(
+            Hive::Stages::Review::Triage.discover_reviewer_files(ctx_pass).map do |path|
+              path.delete_prefix("#{task.folder}/")
+            end
+          )
           before_fix_sha = Hive::ProtectedFiles.snapshot(task.folder, protected_set)
           before_fix_head = git_head(worktree_path)
+          Hive::Stages::Review::FixCompletion.clear_evidence!(ctx_pass)
 
-          fix_result = spawn_fix_agent(task, cfg, ctx_pass, accepted: accepted)
+          fix_result = spawn_fix_agent(
+            task, cfg, ctx_pass, accepted: accepted, pass_start_head: before_fix_head
+          )
           after_fix_sha = Hive::ProtectedFiles.snapshot(task.folder, protected_set)
           after_fix_head = git_head(worktree_path)
 
+          # A successful semantic fallback is intentionally visible in the
+          # task event log before this branch proceeds as a normal fix result.
+          # The event is part of acceptance, not best-effort decoration: if
+          # it cannot be recorded we preserve the error route instead of
+          # silently erasing the forensic distinction from Stop-hook success.
+          if fallback_completion?(fix_result) && !fix_result[:completion_audited]
+            begin
+              emit_completion_fallback!(task, pass, fix_result)
+            rescue StandardError => e
+              fix_result = {
+                status: :error,
+                error_message: "could not audit claude completion fallback: #{e.class}: #{e.message}"
+              }
+            end
+          end
+
           if (tampered = Hive::ProtectedFiles.diff(before_fix_sha, after_fix_sha)).any?
             Hive::Markers.set(task.state_file, :review_error,
                               phase: :fix, reason: "fix_tampered",
@@ -1669,21 +1697,27 @@ module Hive
       def collect_accepted_findings_with_count(ctx)
         out = +""
         count = 0
+        finding_ids = []
         Dir[File.join(ctx.task_folder, "reviews", "*-#{format('%02d', ctx.pass)}.md")].sort.each do |path|
           name = File.basename(path)
           next unless reviewer_file?(name)
 
-          File.readlines(path).each do |line|
+          File.readlines(path).each_with_index do |line, index|
             next unless auto_fix_finding_line?(line)
 
             out << "[#{name}] #{line}"
             count += 1
+            finding_ids << "#{name}:#{index + 1}"
           end
         end
 
         answered = collect_answered_escalation_findings_with_count(ctx)
         out << answered.text
-        AcceptedFindings.new(text: out, count: count + answered.count)
+        AcceptedFindings.new(
+          text: out,
+          count: count + answered.count,
+          finding_ids: finding_ids + answered.finding_ids
+        )
       end
 
       def auto_fix_finding_line?(line)
@@ -1703,7 +1737,7 @@ module Hive
         return collect_legacy_checked_escalations_with_count(path) if questions.empty?
 
         answered = questions.select { |q| q[:answer].strip != "" }
-        return AcceptedFindings.new(text: "", count: 0) if answered.empty?
+        return AcceptedFindings.new(text: "", count: 0, finding_ids: []) if answered.empty?
 
         name = File.basename(path)
         out = +"\n# User answers from #{name}\n"
@@ -1715,7 +1749,11 @@ module Hive
           out << answered_escalation_context_block(name, q[:answer].strip)
           out << "\n"
         end
-        AcceptedFindings.new(text: out, count: answered.size)
+        AcceptedFindings.new(
+          text: out,
+          count: answered.size,
+          finding_ids: answered.map { |q| "#{name}:Q#{q[:number]}" }
+        )
       end
 
       def collect_legacy_checked_escalations(path)
@@ -1723,17 +1761,21 @@ module Hive
       end
 
       def collect_legacy_checked_escalations_with_count(path)
-        return AcceptedFindings.new(text: "", count: 0) unless File.exist?(path)
+        return AcceptedFindings.new(text: "", count: 0, finding_ids: []) unless File.exist?(path)
 
         name = File.basename(path)
-        lines = File.readlines(path).select { |line| auto_fix_finding_line?(line) }
-        return AcceptedFindings.new(text: "", count: 0) if lines.empty?
+        accepted = File.readlines(path).each_with_index.select { |line, _index| auto_fix_finding_line?(line) }
+        return AcceptedFindings.new(text: "", count: 0, finding_ids: []) if accepted.empty?
 
         out = +"\n# Accepted legacy escalations from #{name}\n"
-        lines.each { |line| out << "[#{name}] #{line}" }
-        AcceptedFindings.new(text: out, count: lines.size)
+        accepted.each { |line, _index| out << "[#{name}] #{line}" }
+        AcceptedFindings.new(
+          text: out,
+          count: accepted.size,
+          finding_ids: accepted.map { |_line, index| "#{name}:#{index + 1}" }
+        )
       rescue SystemCallError, IOError
-        AcceptedFindings.new(text: "", count: 0)
+        AcceptedFindings.new(text: "", count: 0, finding_ids: [])
       end
 
       def answered_escalation_context_block(name, text)
@@ -1812,7 +1854,7 @@ module Hive
         File.write(path, body)
       end
 
-      def spawn_fix_agent(task, cfg, ctx, accepted:)
+      def spawn_fix_agent(task, cfg, ctx, accepted:, pass_start_head: nil)
         profile_name = cfg.dig("review", "fix", "agent") || "claude"
         profile = Hive::AgentProfiles.lookup(profile_name, cfg: cfg)
         scope = Hive::Stages::Base.stage_permission_scope(
@@ -1825,6 +1867,7 @@ module Hive
           template,
           hive_state_dir: Hive::Stages::Base.hive_state_dir_for_task_folder(ctx.task_folder)
         )
+        completion_expectation = Hive::Stages::Review::FixCompletion.expectation(ctx)
 
         prompt = Hive::Stages::Base.render_resolved_path(
           template_path,
@@ -1837,6 +1880,7 @@ module Hive
             task_slug: task.slug,
             triage_bias: triage_bias_for(cfg),
             reviewer_sources: reviewer_sources_for(ctx),
+            expected_finding_ids: completion_expectation.finding_ids,
             user_supplied_tag: Hive::Stages::Base.user_supplied_tag
           )
         )
@@ -1853,6 +1897,17 @@ module Hive
           status_mode: :exit_code_only
         }
         if profile.name == :claude
+          if pass_start_head
+            kwargs[:completion_phase] = "review_fix"
+            kwargs[:completion_probe] = lambda do |**_kwargs|
+              Hive::Stages::Review::FixCompletion.probe(
+                ctx: ctx,
+                task_slug: task.slug,
+                pass_start_head: pass_start_head,
+                expectation: completion_expectation
+              )
+            end
+          end
           Hive::Stages::Base.spawn_claude!(
             task,
             cfg,
@@ -1864,6 +1919,36 @@ module Hive
         end
       end
 
+      def fallback_completion?(result)
+        result.is_a?(Hash) && result[:status] == :ok && result[:completion] == :fallback &&
+          result[:fallback_decision]&.accepted?
+      end
+
+      def emit_completion_fallback!(task, pass, result)
+        decision = result.fetch(:fallback_decision)
+        fields = decision.to_h
+        message = completion_fallback_audit_message(task, pass, fields)
+        record = Hive::Events.emit(
+          task_folder: task.folder,
+          slug: task.slug,
+          stage: "6-review", # coding-scoped: review-fix fallback audit event
+          agent: "claude review-fix",
+          event_type: :claude_completion_fallback,
+          message: message
+        )
+        raise Hive::Error, "event log write returned no record" unless record
+
+        record
+      end
+
+      def completion_fallback_audit_message(task, pass, fields)
+        Hive::ClaudeCompletionFallback.audit_message(
+          task_slug: task.slug,
+          pass: pass,
+          fields: fields
+        )
+      end
+
       # The triage bias configured for this run, surfaced into commit
       # trailers so `hive metrics rollback-rate` can compare bias presets.
       # Defaults to "courageous" — same default as Triage.run! itself.
@@ -2223,9 +2308,7 @@ module Hive
       end
 
       def agent_failed?(result)
-        return true if result.nil?
-
-        %i[error timeout].include?(result[:status])
+        result.nil? || result[:status] != :ok
       end
     end
   end
